| OpenCV 3.4.7 Open Source Computer Vision

Public Member Functions | List of all members
cv::bgsegm::BackgroundSubtractorCNT Class Referenceabstract
Improved Background-Foreground Segmentation Methods

Background subtraction based on counting. More...

`#include <opencv2/bgsegm.hpp>`

Inheritance diagram for cv::bgsegm::BackgroundSubtractorCNT:

## Public Member Functions
virtual void | apply (InputArray image, OutputArray fgmask, double learningRate=-1) CV_OVERRIDE=0
| Computes a foreground mask. More...
virtual void | getBackgroundImage (OutputArray backgroundImage) const CV_OVERRIDE=0
| Computes a background image. More...
virtual bool | getIsParallel () const =0
| Returns if we're parallelizing the algorithm. More...
virtual int | getMaxPixelStability () const =0
| Returns maximum allowed credit for a pixel in history. More...
virtual int | getMinPixelStability () const =0
| Returns number of frames with same pixel color to consider stable. More...
virtual bool | getUseHistory () const =0
| Returns if we're giving a pixel credit for being stable for a long time. More...
virtual void | setIsParallel (bool value)=0
| Sets if we're parallelizing the algorithm. More...
virtual void | setMaxPixelStability (int value)=0
| Sets the maximum allowed credit for a pixel in history. More...
virtual void | setMinPixelStability (int value)=0
| Sets the number of frames with same pixel color to consider stable. More...
virtual void | setUseHistory (bool value)=0
| Sets if we're giving a pixel credit for being stable for a long time. More...
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Background subtraction based on counting.

About as fast as MOG2 on a high end system. More than twice faster than MOG2 on cheap hardware (benchmarked on Raspberry Pi3).

Algorithm by Sagi Zeevi ( https://github.com/sagi-z/BackgroundSubtractorCNT )

## Member Function Documentation

## § apply()

virtual void cv::bgsegm::BackgroundSubtractorCNT::apply | ( | InputArray | image,
|  | OutputArray | fgmask,
|  | double | learningRate = `-1`
| ) |  |
| pure virtual

Python:
| fgmask | = | cv.bgsegm_BackgroundSubtractorCNT.apply( | image[, fgmask[, learningRate]] | )

Computes a foreground mask.

Parameters

  image | Next video frame.
  fgmask | The output foreground mask as an 8-bit binary image.
  learningRate | The value between 0 and 1 that indicates how fast the background model is learnt. Negative parameter value makes the algorithm to use some automatically chosen learning rate. 0 means that the background model is not updated at all, 1 means that the background model is completely reinitialized from the last frame.

Implements cv::BackgroundSubtractor.

## § getBackgroundImage()

virtual void cv::bgsegm::BackgroundSubtractorCNT::getBackgroundImage | ( | OutputArray | backgroundImage | ) | const
| pure virtual

Python:
| backgroundImage | = | cv.bgsegm_BackgroundSubtractorCNT.getBackgroundImage( | [, backgroundImage] | )

Computes a background image.

Parameters

  backgroundImage | The output background image.

Note
  Sometimes the background image can be very blurry, as it contain the average background statistics.

Implements cv::BackgroundSubtractor.

## § getIsParallel()

virtual bool cv::bgsegm::BackgroundSubtractorCNT::getIsParallel | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.bgsegm_BackgroundSubtractorCNT.getIsParallel( |  | )

Returns if we're parallelizing the algorithm.

## § getMaxPixelStability()

virtual int cv::bgsegm::BackgroundSubtractorCNT::getMaxPixelStability | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.bgsegm_BackgroundSubtractorCNT.getMaxPixelStability( |  | )

Returns maximum allowed credit for a pixel in history.

## § getMinPixelStability()

virtual int cv::bgsegm::BackgroundSubtractorCNT::getMinPixelStability | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.bgsegm_BackgroundSubtractorCNT.getMinPixelStability( |  | )

Returns number of frames with same pixel color to consider stable.

## § getUseHistory()

virtual bool cv::bgsegm::BackgroundSubtractorCNT::getUseHistory | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.bgsegm_BackgroundSubtractorCNT.getUseHistory( |  | )

Returns if we're giving a pixel credit for being stable for a long time.

## § setIsParallel()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setIsParallel | ( | bool | value | ) |
| pure virtual

Python:
| None | = | cv.bgsegm_BackgroundSubtractorCNT.setIsParallel( | value | )

Sets if we're parallelizing the algorithm.

## § setMaxPixelStability()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setMaxPixelStability | ( | int | value | ) |
| pure virtual

Python:
| None | = | cv.bgsegm_BackgroundSubtractorCNT.setMaxPixelStability( | value | )

Sets the maximum allowed credit for a pixel in history.

## § setMinPixelStability()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setMinPixelStability | ( | int | value | ) |
| pure virtual

Python:
| None | = | cv.bgsegm_BackgroundSubtractorCNT.setMinPixelStability( | value | )

Sets the number of frames with same pixel color to consider stable.

## § setUseHistory()

virtual void cv::bgsegm::BackgroundSubtractorCNT::setUseHistory | ( | bool | value | ) |
| pure virtual

Python:
| None | = | cv.bgsegm_BackgroundSubtractorCNT.setUseHistory( | value | )

Sets if we're giving a pixel credit for being stable for a long time.

The documentation for this class was generated from the following file:

- opencv2/bgsegm.hpp